﻿using Microsoft.SharePoint.Client;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace PiaSys.SPOnTheFlyPermissions.Controllers
{
    public class HomeController : Controller
    {
        private String hostSiteUrl = "https://piasysdev.sharepoint.com/sites/AppDevSite/";
        private Uri redirectUri = new Uri("https://PiaSysSPOnTheFlyPermissions.azurewebsites.net/Home/RedirectFromACS");

        public ActionResult Index()
        {
            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }
        public ActionResult CreateListOnHostWeb()
        {
            // Redirect to OAuthAuthorize.aspx on SharePoint Online
            String OAuthAuthorizationUri = TokenHelper.GetAuthorizationUrl(
                    hostSiteUrl,
                    "Web.Manage",
                    redirectUri.ToString()); // +"&IsDlg=1";

            return (new RedirectResult(OAuthAuthorizationUri));
        }

        [HandleError]
        public ActionResult RedirectFromACS()
        {
            // Get back the Authorization Code
            string authCode = Request.QueryString["code"];

            using (ClientContext context = TokenHelper.GetClientContextWithAuthorizationCode(
                hostSiteUrl,
                "00000003-0000-0ff1-ce00-000000000000",
                authCode,
                null, // Get the Realm from web.config
                redirectUri))
            {
                ListCreationInformation lci = new ListCreationInformation();
                lci.Title = String.Format("List - {0}", Guid.NewGuid());
                lci.Description = "Contacts Created with on the fly permissions";
                lci.TemplateType = (Int32)ListTemplateType.Contacts;
                lci.QuickLaunchOption = QuickLaunchOptions.On;

                List newList = context.Web.Lists.Add(lci);

                ListItem item = newList.AddItem(new ListItemCreationInformation());
                item["Title"] = "Paolo Pialorsi";
                item["Email"] = "paolo@pialorsi.com";
                item["Company"] = "PiaSys.com";
                item.Update();

                context.ExecuteQuery();
            }

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}